function r = evalMesh(p,a,b,type)
% types are:
% 1     value
% 21    deriv for x
% 22    deriv for y
% 31    deriv^2 xx
% 32    deriv^2 xy
% 33    deriv^2 yy

switch type;
    case 1
        r=problemValue(p,a,b);
    case 21
        r=problemDeriv1(p,a,b,1); 
    case 22
        r=problemDeriv1(p,a,b,2);        
    case 31
        r=problemDeriv2(p,a,b,1,1); 
    case 32
        r=problemDeriv2(p,a,b,1,2); 
    case 33
        r=problemDeriv2(p,a,b,2,2); 
end