function y=matvec(A,x,mode)
%function y=matvec(A,x,mode)
%
%Questa funzione esegue il prodotto matrice vettore tra A e x
%
%mode sceglie l'implementazione da usare, 'c' per colonna e 'r' per riga.
[m, n] = size(A);

if [n,1]~=size(x)
    error('numero di colonne di A diverso da dim(x)');
end

y=zeros(m,1);

if mode == 'r' %implementazione per riga
    for i=1:m
        for j=1:n
            y(i)=y(i)+A(i,j)*x(j);
        end
    end
else           %implementazione per colonna
    for j=1:n
        for i=1:m
            y(i)=y(i)+A(i,j)*x(j);
        end
    end
end