function [ a0,a1,a2, f0,f1,f2 ] = initTPP( p, x0, d, step )
% Initialize three point pattern
% p the problem
% d the direction of search
% s the initial step
a0=0;
f0=getValue(p,x0);
a1=step;
f1=getValue(p,x0+a1*d);

if (f1>=f0)
    a2=a1;
    f2=f1;
    a1=a1/2.0;
    f1=getValue(p,x0+a1*d);
    while f0<f1 || f1>f2
        a1=a1/2.0;
        f1=getValue(p,x0+a1*d);    
    end    
else
    a2=a1*2.0;
    f2=getValue(p,x0+a2*d);
    while f1>f2
        a2=a2*2.0;
        f2=getValue(p,x0+a2*d);    
    end        
end

end

