function x = ltri_ones_sys(A,b)
%risolve il sistema lineare come se fosse
%     tril(A,-1)+eye(n)
%ma ottimizza i calcoli
n = length(A);

if(n ~= length(b))
    error('Le dimensioni del vettore b e della matrice A non corrispondono')
end

x = b;
for j = 1:n
    %abbiamo tolto la divisione per 1
    for i = j+1:n
        x(i)=x(i)-A(i,j)*x(j);
    end
end
return
end